#pragma once
#include <Result.h>
#include <Types.h>

namespace MemoryManager
{
    void init();

    Result<void> protect_kernel_sections();

    Result<u64> alloc_physical_page();
    Result<void> free_physical_page(u64 page);

    void lock_page(u64 page);
    void lock_pages(u64 pages, u64 count);

    Result<void> remap(u64 address, usize count, int flags);
    Result<void> remap_unaligned(u64 address, usize count, int flags);

    u64 free();
    u64 used();
    u64 reserved();
}